Rudiments: xmldomnode Class Reference

Rudiments

- Main Page
- Classes

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
xmldomnode Class Reference

## Public Member Functions
| xmldomnode (xmldom *dom, xmldomnode *nullnode)
| xmldomnode (xmldom *dom, xmldomnode *nullnode, xmldomnodetype type, const char *name, const char *value)
| xmldomnode (xmldom *dom, xmldomnode *nullnode, xmldomnodetype type, const char *ns, const char *name, const char *value)
| ~xmldomnode ()
void | cascadeOnDelete ()
void | dontCascadeOnDelete ()
xmldomnodetype | getType () const
const char * | getNamespace () const
const char * | getName () const
const char * | getValue () const
xmldom * | getTree () const
xmldomnode * | getParent () const
uint64_t | getPosition () const
xmldomnode * | getPreviousSibling () const
xmldomnode * | getPreviousTagSibling () const
xmldomnode * | getPreviousTagSibling (const char *name) const
xmldomnode * | getPreviousTagSibling (const char *ns, const char *name) const
xmldomnode * | getPreviousTagSiblingIgnoringCase (const char *name) const
xmldomnode * | getPreviousTagSiblingIgnoringCase (const char *ns, const char *name) const
xmldomnode * | getPreviousTagSibling (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getPreviousTagSibling (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getPreviousTagSiblingIgnoringCase (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getPreviousTagSiblingIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getNextSibling () const
xmldomnode * | getNextTagSibling () const
xmldomnode * | getNextTagSibling (const char *name) const
xmldomnode * | getNextTagSibling (const char *ns, const char *name) const
xmldomnode * | getNextTagSiblingIgnoringCase (const char *name) const
xmldomnode * | getNextTagSiblingIgnoringCase (const char *ns, const char *name) const
xmldomnode * | getNextTagSibling (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getNextTagSibling (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getNextTagSiblingIgnoringCase (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getNextTagSiblingIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getNextTagSiblingInSet (const char *const *set) const
xmldomnode * | getNextTagSiblingInSet (const char *ns, const char *const *set) const
uint64_t | getChildCount () const
xmldomnode * | getFirstChild (const char *name) const
xmldomnode * | getFirstChild (const char *ns, const char *name) const
xmldomnode * | getFirstChildIgnoringCase (const char *name) const
xmldomnode * | getFirstChildIgnoringCase (const char *ns, const char *name) const
xmldomnode * | getChild (uint64_t position) const
xmldomnode * | getFirstChild (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstChild (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstChildIgnoringCase (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstChildIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagChild () const
xmldomnode * | getFirstTagChild (const char *name) const
xmldomnode * | getFirstTagChild (const char *ns, const char *name) const
xmldomnode * | getFirstTagChildIgnoringCase (const char *name) const
xmldomnode * | getFirstTagChildIgnoringCase (const char *ns, const char *name) const
xmldomnode * | getFirstTagChild (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagChild (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagChildIgnoringCase (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagChildIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagChildInSet (const char *const *set) const
xmldomnode * | getFirstTagChildInSet (const char *ns, const char *const *set) const
xmldomnode * | getFirstTagDescendent (const char *name) const
xmldomnode * | getFirstTagDescendent (const char *ns, const char *name) const
xmldomnode * | getFirstTagDescendentIgnoringCase (const char *name) const
xmldomnode * | getFirstTagDescendentIgnoringCase (const char *ns, const char *name) const
xmldomnode * | getFirstTagDescendent (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagDescendent (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagDescendentIgnoringCase (const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagDescendentIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue) const
xmldomnode * | getFirstTagDescendentInSet (const char *const *set) const
xmldomnode * | getFirstTagDescendentInSet (const char *ns, const char *const *set) const
xmldomnode * | getNextTag () const
xmldomnode * | getNextTag (xmldomnode *top) const
xmldomnode * | getPreviousTag () const
xmldomnode * | getPreviousTag (xmldomnode *top) const
uint64_t | getAttributeCount () const
xmldomnode * | getAttribute (const char *name) const
xmldomnode * | getAttributeIgnoringCase (const char *name) const
xmldomnode * | getAttribute (uint64_t position) const
const char * | getAttributeValue (const char *name) const
const char * | getAttributeValue (uint64_t position) const
constnamevaluepairs * | getAttributes () const
void | setAttributeValue (const char *name, const char *value)
void | setAttributeValue (const char *name, int64_t value)
void | setAttributeValue (const char *name, uint64_t value)
xmldomnode * | getNullNode () const
bool | isNullNode () const
void | setType (xmldomnodetype type)
void | setNamespace (const char *ns)
void | setName (const char *name)
void | setName (const char *ns, const char *name)
void | setValue (const char *value)
void | setParent (xmldomnode *parent)
void | setPreviousSibling (xmldomnode *previous)
void | setNextSibling (xmldomnode *next)
bool | insertChild (xmldomnode *child, uint64_t position)
bool | appendChild (xmldomnode *child)
xmldomnode * | insertTag (const char *tag, uint64_t position)
xmldomnode * | insertTag (const char *ns, const char *tag, uint64_t position)
bool | insertXml (const char *xml, uint64_t position)
bool | insertXmlFile (const char *xmlfile, uint64_t position)
xmldomnode * | appendTag (const char *tag)
xmldomnode * | appendTag (const char *ns, const char *tag)
bool | appendXml (const char *xml)
bool | appendXmlFile (const char *xmlfile)
bool | moveChild (xmldomnode *child, xmldomnode *parent, uint64_t position)
bool | deleteChild (uint64_t position)
bool | deleteChild (xmldomnode *child)
bool | deleteFirstChild (const char *name)
bool | deleteFirstChild (const char *ns, const char *name)
bool | deleteFirstChildIgnoringCase (const char *name)
bool | deleteFirstChildIgnoringCase (const char *ns, const char *name)
bool | deleteFirstChild (const char *name, const char *attributename, const char *attributevalue)
bool | deleteFirstChild (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | deleteFirstChildIgnoringCase (const char *name, const char *attributename, const char *attributevalue)
bool | deleteFirstChildIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | deleteChildren ()
bool | deleteChildren (const char *name)
bool | deleteChildren (const char *ns, const char *name)
bool | deleteChildrenIgnoringCase (const char *name)
bool | deleteChildrenIgnoringCase (const char *ns, const char *name)
bool | deleteChildren (const char *name, const char *attributename, const char *attributevalue)
bool | deleteChildren (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | deleteChildrenIgnoringCase (const char *name, const char *attributename, const char *attributevalue)
bool | deleteChildrenIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | deleteDescendents (const char *name)
bool | deleteDescendents (const char *ns, const char *name)
bool | deleteDescendentsIgnoringCase (const char *name)
bool | deleteDescendentsIgnoringCase (const char *ns, const char *name)
bool | deleteDescendents (const char *name, const char *attributename, const char *attributevalue)
bool | deleteDescendents (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | deleteDescendentsIgnoringCase (const char *name, const char *attributename, const char *attributevalue)
bool | deleteDescendentsIgnoringCase (const char *ns, const char *name, const char *attributename, const char *attributevalue)
bool | renameFirstChild (const char *oldname, const char *newname)
bool | renameFirstChild (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | renameFirstChildIgnoringCase (const char *oldname, const char *newname)
bool | renameFirstChildIgnoringCase (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | renameChildren (const char *oldname, const char *newname)
bool | renameChildren (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | renameChildrenIgnoringCase (const char *oldname, const char *newname)
bool | renameChildrenIgnoringCase (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | renameDescendents (const char *oldname, const char *newname)
bool | renameDescendents (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | renameDescendentsIgnoringCase (const char *oldname, const char *newname)
bool | renameDescendentsIgnoringCase (const char *oldns, const char *oldname, const char *newns, const char *newname)
bool | insertText (const char *value, uint64_t position)
bool | appendText (const char *value)
bool | insertAttribute (xmldomnode *attribute, uint64_t position)
bool | appendAttribute (xmldomnode *attribute)
bool | insertAttribute (const char *name, const char *value, uint64_t position)
bool | appendAttribute (const char *name, const char *value)
bool | deleteAttribute (uint64_t position)
bool | deleteAttribute (const char *name)
bool | deleteAttribute (xmldomnode *attribute)
bool | unwrapChild (xmldomnode *child)
bool | unwrapFirstChild (const char *name)
bool | unwrapFirstChild (const char *ns, const char *name)
bool | unwrapFirstChildIgnoringCase (const char *name)
bool | unwrapFirstChildIgnoringCase (const char *ns, const char *name)
bool | unwrapChildren (const char *name)
bool | unwrapChildren (const char *ns, const char *name)
bool | unwrapChildrenIgnoringCase (const char *name)
bool | unwrapChildrenIgnoringCase (const char *ns, const char *name)
bool | unwrapDescendents (const char *name)
bool | unwrapDescendents (const char *ns, const char *name)
bool | unwrapDescendentsIgnoringCase (const char *name)
bool | unwrapDescendentsIgnoringCase (const char *ns, const char *name)
xmldomnode * | wrapChild (xmldomnode *child, const char *name)
xmldomnode * | wrapChild (xmldomnode *child, const char *ns, const char *name)
xmldomnode * | wrapChildren (xmldomnode *startchild, xmldomnode *endchild, const char *name)
xmldomnode * | wrapChildren (xmldomnode *startchild, xmldomnode *endchild, const char *ns, const char *name)
xmldomnode * | wrapChildren (const char *name)
xmldomnode * | wrapChildren (const char *ns, const char *name)
xmldomnode * | clone ()
stringbuffer * | xml () const
void | print (stringbuffer *strb) const
void | print (filedescriptor *fd) const
stringbuffer * | getPath () const
xmldomnode * | getChildByPath (const char *path) const
xmldomnode * | getAttributeByPath (const char *path, uint64_t position) const
xmldomnode * | getAttributeByPath (const char *path, const char *name) const
const char * | getAttributeValueByPath (const char *path, uint64_t position) const
const char * | getAttributeValueByPath (const char *path, const char *name) const
void | setData (void *data)
void * | getData ()

## Static Public Member Functions
static xmldomnode * | createNullNode (xmldom *dom)

## Detailed Description

The xmldomnode class provides a generic container for DOM tree elements. One can navigate the nodes of the tree, modify the tree and read or modify the data that the nodes contain by calling methods in this class.

A DOM tree node can be one of the following: the document root a tag a tag attribute a segment of text a comment a segment of CDATA

Each node may contain the following data: (For some node types, the data container is unused and set to NULL) type namespace name value parent node next sibling previous sibling a list of attribute nodes a list of child nodes

Here is a breakdown by node type:

        For the document root:
                type - ROOT_XMLDOMNODETYPE
                namespace - unused
                name - "document"
                value - unused
                parent node - unused
                next sibling - unused
                previous sibling - unused
                a list of attribute nodes - unused
                a list of child nodes - the xml version tag, the doctype tag
                                        and the top-level enclosing tag

        For a tag:
                type - TAG_XMLDOMNODETYPE
                namespace - the tag namespace
                name - the tag name
                value - unused
                parent node - the parent tag or document root
                next sibling - can be another tag, a segment of text,
                                         a comment or a segment of cdata
                previous sibling - can be another tag, a segment of text,
                                         a comment or a segment of cdata
                a list of attribute nodes - a list of attribute nodes
                a list of child nodes - a list of tags, text segments, comments
                                        and/or cdata segments

        For a tag attribute:
                type - ATTRIBUTE_XMLDOMNODETYPE
                namespace - unused
                name - the attribute name
                value - the attribute value
                    (note that for tags with standalone
                    attributes, the name and value are the same)
                parent node - the tag containing the attributes
                next sibling - the next attribute
                previous sibling - the previous attribute
                a list of attribute nodes - unused
                a list of child nodes - unused

        For a segment of text:
                type - TEXT_XMLDOMNODETYPE
                namespace - unused
                name - "text"
                value - the text itself
                parent node - the tag containing the text
                next sibling - can be a tag, a comment or a segment of cdata
                previous sibling - can be a tag, a comment or a segment of cdata
                a list of attribute nodes - unused
                a list of child nodes - unused

        For a comment:
                type - COMMENT_XMLDOMNODETYPE
                namespace - unused
                name - "comment"
                value - the comment itself
                parent node - the tag containing the comment
                next sibling - can be a tag, a segment of text, another
                                comment or a segment of cdata
                previous sibling - can be a tag, a segment of text, another
                                comment or a segment of cdata
                a list of attribute nodes - unused
                a list of child nodes - unused

        For a segment of cdata:
                type - CDATA_XMLDOMNODETYPE
                namespace - unused
                name - "cdata"
                value - the cdata itself
                parent node - the tag containing the cdata
                next sibling - can be a tag, a segment of text, a comment
                                or another segment of cdata
                previous sibling - can be a tag, a segment of text, a comment
                                or another segment of cdata
                a list of attribute nodes - unused
                a list of child nodes - unused

## Constructor & Destructor Documentation

xmldomnode::xmldomnode | ( | xmldom * | dom,
|  | xmldomnode * | nullnode
| ) |  |

Creates a new node and intializes its member variables to NULL.

Your application should pass in a special "nullnode" which may be created by the static method createNullNode() below.

This will keep command chaining like this:

mynode->getFirstChild("node1")-> getFirstChild("node2")->getName("node3");

from causing the program to crash trying to dereference a NULL pointer if, for example, "node2" doesn't exist.

xmldomnode::xmldomnode | ( | xmldom * | dom,
|  | xmldomnode * | nullnode,
|  | xmldomnodetype | type,
|  | const char * | name,
|  | const char * | value
| ) |  |

Creates a new node (see xmldomnode(xmldom *, xmldomnode *) and intializes its member variables to the values passed in.

xmldomnode::xmldomnode | ( | xmldom * | dom,
|  | xmldomnode * | nullnode,
|  | xmldomnodetype | type,
|  | const char * | ns,
|  | const char * | name,
|  | const char * | value
| ) |  |

Creates a new node (see xmldomnode(xmldom *, xmldomnode *) and intializes its member variables to the values passed in.

xmldomnode::~xmldomnode | ( |  | ) |

Deletes the node, all attribute nodes and optionally all child nodes, recursively.

## Member Function Documentation

bool xmldomnode::appendAttribute | ( | xmldomnode * | attribute | ) |

Appends "attribute" to the list of attributes.

bool xmldomnode::appendAttribute | ( | const char * | name,
|  | const char * | value
| ) |  |

Creates an attribute node with "name" and "value" and appends it to the list of attributes.

bool xmldomnode::appendChild | ( | xmldomnode * | child | ) |

Appends "child" to the list of child nodes.

xmldomnode* xmldomnode::appendTag | ( | const char * | tag | ) |

Appends a new node of type TAG_XMLDOMNODETYPE with name "tag" to the list of child nodes.

Returns the new node on success or the null node on failure.

xmldomnode* xmldomnode::appendTag | ( | const char * | ns,
|  | const char * | tag
| ) |  |

Appends a new node of type TAG_XMLDOMNODETYPE with namespace "ns" and name "tag" to the list of child nodes.

Returns the new node on success or the null node on failure.

bool xmldomnode::appendText | ( | const char * | value | ) |

Appends a child node of type TEXT_XMLDOMNODE with value "value" to the list of child nodes.

bool xmldomnode::appendXml | ( | const char * | xml | ) |

Parses "xml" and appends the result to the list of child nodes.

Returns true on success or false on failure.

bool xmldomnode::appendXmlFile | ( | const char * | xmlfile | ) |

Parses file "xml" and appends the result to the list of child nodes.

Returns true on success or false on failure.

void xmldomnode::cascadeOnDelete | ( |  | ) |

Instructs the destructor to recursively delete all child nodes. This is the default behavior.

xmldomnode* xmldomnode::clone | ( |  | ) |

Clones this node and all of its children and returns a pointer to the clone.

static xmldomnode* xmldomnode::createNullNode | ( | xmldom * | dom | ) |
| static

Creates a special "null node" whose parent, next sibling, previous sibling, and child point back to itself. This special node should be passed in when creating new xmldomnodes.

This method allocates xmldomnode internally and passes a pointer back. The calling program must ultimately deallocate the node.

bool xmldomnode::deleteAttribute | ( | uint64_t | position | ) |

Deletes the attribute at "position". The position of the next attribute (and all successive attributes) is decremented.

bool xmldomnode::deleteAttribute | ( | const char * | name | ) |

Searches the list of attribute nodes for an attribute named "name" and deletes it. The position of the next attribute (and all successive attributes) is decremented.

bool xmldomnode::deleteAttribute | ( | xmldomnode * | attribute | ) |

Searches the list of attribute nodes for "attribute" and deletes it. The position of the next attribute (and all successive attributes) is decremented.

bool xmldomnode::deleteChild | ( | uint64_t | position | ) |

Deletes the child node at "position". The position of the next sibling (and all successive siblings) is decremented.

bool xmldomnode::deleteChild | ( | xmldomnode * | child | ) |

Deletes child node "child". The position of the next sibling (and all successive siblings) is decremented.

The behavior is undefined if "child" is not actually a child of this node.

bool xmldomnode::deleteChildren | ( |  | ) |

Deletes all child nodes.

bool xmldomnode::deleteChildren | ( | const char * | name | ) |

Deletes all child nodes named "name".

bool xmldomnode::deleteChildren | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes all child nodes in namespace "ns" named "name".

bool xmldomnode::deleteChildren | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all child nodes named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteChildren | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all child nodes in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteChildrenIgnoringCase | ( | const char * | name | ) |

Deletes all child nodes named "name" (ignoring case).

bool xmldomnode::deleteChildrenIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes all child nodes in namespace "ns" named "name" (both ignoring case).

bool xmldomnode::deleteChildrenIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all child nodes named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteChildrenIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all child nodes in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute name "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteDescendents | ( | const char * | name | ) |

Deletes all descendents named "name".

bool xmldomnode::deleteDescendents | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes all descendents in namespace "ns" named "name".

bool xmldomnode::deleteDescendents | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all descendents named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent is not checked, and the first descendent with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteDescendents | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all descendents in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent is not checked, and the first descendent with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteDescendentsIgnoringCase | ( | const char * | name | ) |

Deletes all descendents named "name" (ignoring case).

bool xmldomnode::deleteDescendentsIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes all descendents in namespace "ns" named "name" (both ignoring case).

bool xmldomnode::deleteDescendentsIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all descendents named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent is not checked, and the first descendent with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteDescendentsIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes all descendents in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent is not checked, and the first descendent with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteFirstChild | ( | const char * | name | ) |

Deletes the first child named "name". The position of the next sibling (and all successive siblings) is decremented.

bool xmldomnode::deleteFirstChild | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes the first child in namespace "ns" named "name". The position of the next sibling (and all successive siblings) is decremented.

bool xmldomnode::deleteFirstChild | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes the first child node named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteFirstChild | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes the first child node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteFirstChildIgnoringCase | ( | const char * | name | ) |

Deletes the first child named "name" (ignoring case). The position of the next sibling (and all successive siblings) is decremented.

bool xmldomnode::deleteFirstChildIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

Deletes the first child in namespace "ns" named "name" (both ignoring case). The position of the next sibling (and all successive siblings) is decremented.

bool xmldomnode::deleteFirstChildIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes the first child node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

bool xmldomnode::deleteFirstChildIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  |

Deletes the first child node in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

void xmldomnode::dontCascadeOnDelete | ( |  | ) |

Instructs the destructor not to recursively delete all child nodes. The default behavior is to delete all child nodes.

xmldomnode* xmldomnode::getAttribute | ( | const char * | name | ) | const

Returns the attribute named "name" or the nullnode if not found.

xmldomnode* xmldomnode::getAttribute | ( | uint64_t | position | ) | const

Returns the attribute node at index "position" or the nullnode if not found.

xmldomnode* xmldomnode::getAttributeByPath | ( | const char * | path,
|  | uint64_t | position
| ) |  | const

Returns the attribute node at index "position" of the child element with "path" of the form:

/element[index]/element[index]/...

Returns the null node if the specified element was not found.

xmldomnode* xmldomnode::getAttributeByPath | ( | const char * | path,
|  | const char * | name
| ) |  | const

Returns the attribute node named "name" of the child element with "path" of the form:

/element[index]/element[index]/...

Returns the null node if the specified element was not found.

uint64_t xmldomnode::getAttributeCount | ( |  | ) | const

Returns the number of attributes.

xmldomnode* xmldomnode::getAttributeIgnoringCase | ( | const char * | name | ) | const

Returns the attribute named "name" (ignoring case) or the nullnode if not found.

constnamevaluepairs* xmldomnode::getAttributes | ( |  | ) | const

Returns the attribute names and values in a constnamevaluepairs dictionary. The instance of constnamevaluepairs is allocated internally and must be deleted by the calling program. Returns NULL if the node is a nullNode and an empty dictionary if the node has no attributes.

const char* xmldomnode::getAttributeValue | ( | const char * | name | ) | const

Returns the value of the attribute named "name" or the nullnode if not found.

const char* xmldomnode::getAttributeValue | ( | uint64_t | position | ) | const

Returns the value of the attribute node at index "position" or the nullnode if not found.

const char* xmldomnode::getAttributeValueByPath | ( | const char * | path,
|  | uint64_t | position
| ) |  | const

Returns the value of the attribute at index "position" of the child element with "path" of the form:

/element[index]/element[index]/...

Returns the null node if the specified element was not found.

const char* xmldomnode::getAttributeValueByPath | ( | const char * | path,
|  | const char * | name
| ) |  | const

Returns the value of the attribute named "name" of the child element with "path" of the form:

/element[index]/element[index]/...

Returns the null node if the specified element was not found.

xmldomnode* xmldomnode::getChild | ( | uint64_t | position | ) | const

Returns the child node at index "position" or the nullnode if not found.

xmldomnode* xmldomnode::getChildByPath | ( | const char * | path | ) | const

Returns the child element with "path" of the form:

/element[index]/element[index]/...

Returns the null node if the specified element was not found.

uint64_t xmldomnode::getChildCount | ( |  | ) | const

Returns the number of immediate child nodes.

void* xmldomnode::getData | ( |  | ) |

Allows an app to get the arbitrary data associated with the node using setData().

xmldomnode* xmldomnode::getFirstChild | ( | const char * | name | ) | const

Returns the firest child node named "name" or the nullnode if not found.

xmldomnode* xmldomnode::getFirstChild | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the firest child node in namespace "ns" named "name" or the nullnode if not found.

xmldomnode* xmldomnode::getFirstChild | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node named "name" with an attribute named "attributename" with value "attributevalue". If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstChild | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue". If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstChildIgnoringCase | ( | const char * | name | ) | const

Returns the child node named "name" (ignoring case) or the nullnode if not found.

xmldomnode* xmldomnode::getFirstChildIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the child node in namespace "ns" (ignoring case) named "name" (ignoring case) or the nullnode if not found.

xmldomnode* xmldomnode::getFirstChildIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case). If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstChildIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case). If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChild | ( |  | ) | const

Returns the first child node whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChild | ( | const char * | name | ) | const

Returns the first child node named "name" whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChild | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the first child node in namespace "ns" named "name" whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChild | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChild | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildIgnoringCase | ( | const char * | name | ) | const

Returns the first child node named "name" (ignoring case) whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the first child node in namespace "ns" named "name" (both ignoring case) whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first child node in namespace "ns" (ignoring case) named "name" * (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildInSet | ( | const char *const * | set | ) | const

Returns the first child node whose type is TAG_XMLDOMNODE and whose name matches one of the members of the NULL-terminated array "set". If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagChildInSet | ( | const char * | ns,
|  | const char *const * | set
| ) |  | const

Returns the first child node in namespace "ns" whose name matches one of the members of the NULL-terminated array "set" and whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendent | ( | const char * | name | ) | const

Returns the first descendent node named "name" whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendent | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the first descendent node in namespace "ns" named "name" whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendent | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first descendent node named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent node is not checked, and the first descendent node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendent | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first descendent node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent node is not checked, and the first descendent node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentIgnoringCase | ( | const char * | name | ) | const

Returns the first descendent node named "name" (ignoring case) whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the first descendent node in namespace "ns" named "name" (both ignoring case) whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first descendent node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent node is not checked, and the first descendent node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the first descendent node in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the descendent node is not checked, and the first descendent node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentInSet | ( | const char *const * | set | ) | const

Returns the first descendent node whose type is TAG_XMLDOMNODE and whose name matches one of the members of the NULL-terminated array "set". If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getFirstTagDescendentInSet | ( | const char * | ns,
|  | const char *const * | set
| ) |  | const

Returns the first descendent node in namespace "ns" whose name matches one of the members of the NULL-terminated array "set" and whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

const char* xmldomnode::getName | ( |  | ) | const

Returns the name of the node.

const char* xmldomnode::getNamespace | ( |  | ) | const

Returns the namespace of the node.

xmldomnode* xmldomnode::getNextSibling | ( |  | ) | const

Returns a pointer to the next sibling node or the nullnode if none exists.

xmldomnode* xmldomnode::getNextTag | ( |  | ) | const

Returns the next node in a depth-first traversal whose type is TAG_XMLDOMNODE.

xmldomnode* xmldomnode::getNextTag | ( | xmldomnode * | top | ) | const

Returns the next node in a depth-first traversal of the nodes beneath "top" whose type is TAG_XMLDOMNODE.

The behavior is undefined if "top" is not a direct ancestor of this node.

xmldomnode* xmldomnode::getNextTagSibling | ( |  | ) | const

Returns a pointer to the next sibling node whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSibling | ( | const char * | name | ) | const

Returns the next sibling node named "name" whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getNextTagSibling | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the next sibling node in namespace "ns" named "name" whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getNextTagSibling | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the next sibling node named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSibling | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the next sibling node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSiblingIgnoringCase | ( | const char * | name | ) | const

Returns the next sibling node named "name" (ignoring case) whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getNextTagSiblingIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the next sibling node in namespace "ns" named "name" (both ignoring case) whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getNextTagSiblingIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the next sibling node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSiblingIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the next sibling node in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSiblingInSet | ( | const char *const * | set | ) | const

Returns the next sibling node whose type is TAG_XMLDOMNODE and whose name matches one of the members of the NULL-terminated array "set". If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNextTagSiblingInSet | ( | const char * | ns,
|  | const char *const * | set
| ) |  | const

Returns the next sibling node in namespace "ns" whose name matches one of the members of the NULL-terminated array "set" and whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getNullNode | ( |  | ) | const

Returns the nullnode used by this node.

xmldomnode* xmldomnode::getParent | ( |  | ) | const

Returns a pointer to the parent node or the nullnode if none exists.

stringbuffer* xmldomnode::getPath | ( |  | ) | const

If the xmldomnode is an element, returns the "path" of the xmldomnode. The path will have the following form:

/element[index]/element[index]/...

The return value is allocated inside the method and must be deallocated by the calling program.

uint64_t xmldomnode::getPosition | ( |  | ) | const

Returns the position of the node, relative to its siblings.

xmldomnode* xmldomnode::getPreviousSibling | ( |  | ) | const

Returns a pointer to the previous sibling node or the nullnode if none exists.

xmldomnode* xmldomnode::getPreviousTag | ( |  | ) | const

Returns the previous node in a depth-first traversal whose type is TAG_XMLDOMNODE.

xmldomnode* xmldomnode::getPreviousTag | ( | xmldomnode * | top | ) | const

Returns the previous node in a depth-first traversal of the nodes beneath "top" whose type is TAG_XMLDOMNODE.

The behavior is undefined if "top" is not a direct ancestor of this node.

xmldomnode* xmldomnode::getPreviousTagSibling | ( |  | ) | const

Returns a pointer to the previous sibling node whose type is TAG_XMLDOMNODE. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getPreviousTagSibling | ( | const char * | name | ) | const

Returns the previous sibling node named "name" whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getPreviousTagSibling | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the previous sibling node in namespace "ns" named "name" whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getPreviousTagSibling | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the previous sibling node named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getPreviousTagSibling | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the previous sibling node in namespace "ns" named "name" with an attribute named "attributename" with value "attributevalue" whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getPreviousTagSiblingIgnoringCase | ( | const char * | name | ) | const

Returns the previous sibling node named "name" (ignoring case) whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getPreviousTagSiblingIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  | const

Returns the previous sibling node in namespace "napesp" named "name" (both ignoring case) whose type is TAG_XMLDOMNODE or the nullnode if not found.

xmldomnode* xmldomnode::getPreviousTagSiblingIgnoringCase | ( | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the previous sibling node named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldomnode* xmldomnode::getPreviousTagSiblingIgnoringCase | ( | const char * | ns,
|  | const char * | name,
|  | const char * | attributename,
|  | const char * | attributevalue
| ) |  | const

Returns the previous sibling node in namespace "ns" (ignoring case) named "name" (ignoring case) with an attribute named "attributename" with value "attributevalue" (both ignoring case) whose type is TAG_XMLDOMNODE. If "name" is null, then the name of the child node is not checked, and the first child node with any name (with matching attribute name/value) will be returned. If no match is found, nullnode is returned.

xmldom* xmldomnode::getTree | ( |  | ) | const

Returns a pointer to the tree that this node is attached to or NULL if it isn't attached to any tree.

xmldomnodetype xmldomnode::getType | ( |  | ) | const

Returns the type of the node.

const char* xmldomnode::getValue | ( |  | ) | const

Returns the value of node.

bool xmldomnode::insertAttribute | ( | xmldomnode * | attribute,
|  | uint64_t | position
| ) |  |

Inserts "attribute" into the list of attributes at "position". The position of the next attribute (and all successive attributes) is incremented.

bool xmldomnode::insertAttribute | ( | const char * | name,
|  | const char * | value,
|  | uint64_t | position
| ) |  |

Creates an attribute node with "name" and "value" and inserts it into the list of attributes at "position". The position of the next attribute (and all successive attributes) is incremented.

bool xmldomnode::insertChild | ( | xmldomnode * | child,
|  | uint64_t | position
| ) |  |

Inserts "child" into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented.

xmldomnode* xmldomnode::insertTag | ( | const char * | tag,
|  | uint64_t | position
| ) |  |

Inserts a new node of type TAG_XMLDOMNODETYPE with name "tag" into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented.

Returns the new node on success or the null node on failure.

xmldomnode* xmldomnode::insertTag | ( | const char * | ns,
|  | const char * | tag,
|  | uint64_t | position
| ) |  |

Inserts a new node of type TAG_XMLDOMNODETYPE with namespace "ns" and name "tag" into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented.

Returns the new node on success or the null node on failure.

bool xmldomnode::insertText | ( | const char * | value,
|  | uint64_t | position
| ) |  |

Inserts a child node of type TEXT_XMLDOMNODE with value "value" into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented.

bool xmldomnode::insertXml | ( | const char * | xml,
|  | uint64_t | position
| ) |  |

Parses "xml" and inserts the result into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented as appropriate.

Returns true on success or false on failure.

bool xmldomnode::insertXmlFile | ( | const char * | xmlfile,
|  | uint64_t | position
| ) |  |

Parses file "xmlfile" and inserts the result into the list of child nodes at "position". The position of the next sibling (and all successive siblings) is incremented as appropriate.

Returns true on success or false on failure.

bool xmldomnode::isNullNode | ( |  | ) | const

Returns true if this node is the special nullnode and false otherwise.

bool xmldomnode::moveChild | ( | xmldomnode * | child,
|  | xmldomnode * | parent,
|  | uint64_t | position
| ) |  |

Moves "child" from its current position into the list of child nodes for "parent" at "position".

The behavior is undefined if "child" is not actually a child of this node.

void xmldomnode::print | ( | stringbuffer * | strb | ) | const

Prints a text representation of the tree starting at this node into "strb".

void xmldomnode::print | ( | filedescriptor * | fd | ) | const

Prints a text representation of the tree starting at this node to filedescriptor "fd".

bool xmldomnode::renameChildren | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds all child nodes named "oldname" and renames them "newname".

bool xmldomnode::renameChildren | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds all child nodes named "oldname" in namespace "oldns" and renames them "newname" with namespace "newns".

bool xmldomnode::renameChildrenIgnoringCase | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds all child nodes named "oldname" (ignoring case) and renames them "newname".

bool xmldomnode::renameChildrenIgnoringCase | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds all child nodes named "oldname" in namespace "oldns" (both ignoring case) and renames them "newname" with namespace "newns".

bool xmldomnode::renameDescendents | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds all descendents named "oldname" and renames them "newname".

bool xmldomnode::renameDescendents | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds all descendents named "oldname" in namespace "oldns" and renames them "newname" with namespace "newns".

bool xmldomnode::renameDescendentsIgnoringCase | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds all descendents named "oldname" (ignoring case) and renames them "newname".

bool xmldomnode::renameDescendentsIgnoringCase | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds all descendents named "oldname" in namespace "oldns" (both ignoring case) and renames them "newname" with namespace "newns".

bool xmldomnode::renameFirstChild | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds the first child node named "oldname" and renames it "newname".

bool xmldomnode::renameFirstChild | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds the first child node named "oldname" in namespace "oldns" and renames it "newname" with namespace "newns".

bool xmldomnode::renameFirstChildIgnoringCase | ( | const char * | oldname,
|  | const char * | newname
| ) |  |

Finds the first child node named "oldname" (ignoring case) and renames it "newname".

bool xmldomnode::renameFirstChildIgnoringCase | ( | const char * | oldns,
|  | const char * | oldname,
|  | const char * | newns,
|  | const char * | newname
| ) |  |

Finds the first child node named "oldname" in namespace "oldns" (both ignoring case) and renames it "newname" with namespace "newns".

void xmldomnode::setAttributeValue | ( | const char * | name,
|  | const char * | value
| ) |  |

Sets the value of the attribute named "name" to "value". Creates attribute "name" if it didn't previously exist.

void xmldomnode::setAttributeValue | ( | const char * | name,
|  | int64_t | value
| ) |  |

Sets the value of the attribute named "name" to "value". Creates attribute "name" if it didn't previously exist.

void xmldomnode::setAttributeValue | ( | const char * | name,
|  | uint64_t | value
| ) |  |

Sets the value of the attribute named "name" to "value". Creates attribute "name" if it didn't previously exist.

void xmldomnode::setData | ( | void * | data | ) |

Allows an app to associate arbitrary data with the node.

void xmldomnode::setName | ( | const char * | name | ) |

Sets the node name to "name".

void xmldomnode::setName | ( | const char * | ns,
|  | const char * | name
| ) |  |

Sets the node namespace to "ns" and node name to "name".

void xmldomnode::setNamespace | ( | const char * | ns | ) |

Sets the node namespace to "ns".

void xmldomnode::setNextSibling | ( | xmldomnode * | next | ) |

Sets the next sibling of the node to "next".

void xmldomnode::setParent | ( | xmldomnode * | parent | ) |

Sets the parent of the node to "parent".

void xmldomnode::setPreviousSibling | ( | xmldomnode * | previous | ) |

Sets the previous sibling of the node to "previous".

void xmldomnode::setType | ( | xmldomnodetype | type | ) |

Sets the node type to "type".

void xmldomnode::setValue | ( | const char * | value | ) |

Sets the node value to "value".

bool xmldomnode::unwrapChild | ( | xmldomnode * | child | ) |

Moves all children of "child" out of "child" and then deletes "child".

The behavior is undefined if "child" is not actually a child of this node.

bool xmldomnode::unwrapChildren | ( | const char * | name | ) |

For each tag child named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapChildren | ( | const char * | ns,
|  | const char * | name
| ) |  |

For each tag child in namespace "ns" named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapChildrenIgnoringCase | ( | const char * | name | ) |

For each tag child named "name" (ignoring case), moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapChildrenIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

For each tag child in namespace "ns" named "name" (both ignoring case), moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapDescendents | ( | const char * | name | ) |

For each tag descendent named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapDescendents | ( | const char * | ns,
|  | const char * | name
| ) |  |

For each tag descendent in namespace "ns" named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapDescendentsIgnoringCase | ( | const char * | name | ) |

For each tag descendent named "name" (ignoring case), moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapDescendentsIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

For each tag descendent in namespace "ns" named "name" (both ignoring case), moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapFirstChild | ( | const char * | name | ) |

Finds the first tag child named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapFirstChild | ( | const char * | ns,
|  | const char * | name
| ) |  |

Finds the first tag child in namespace "ns" named "name", moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapFirstChildIgnoringCase | ( | const char * | name | ) |

Finds the first tag child named "name" (ignoring case), moves all children out of the tag, then deletes the tag.

bool xmldomnode::unwrapFirstChildIgnoringCase | ( | const char * | ns,
|  | const char * | name
| ) |  |

Finds the first tag child in namespace "ns" named "name" (both ignoring case), moves all children out of the tag, then deletes the tag.

xmldomnode* xmldomnode::wrapChild | ( | xmldomnode * | child,
|  | const char * | name
| ) |  |

Wraps the specified child with a tag named "name". Returns the newly new created tag node.

The behavior is undefined if "child" is not actually a child of this node.

xmldomnode* xmldomnode::wrapChild | ( | xmldomnode * | child,
|  | const char * | ns,
|  | const char * | name
| ) |  |

Wraps the specified child with a tag named "name" with namespace "ns". Returns the newly new created tag node.

The behavior is undefined if "child" is not actually a child of this node.

xmldomnode* xmldomnode::wrapChildren | ( | xmldomnode * | startchild,
|  | xmldomnode * | endchild,
|  | const char * | name
| ) |  |

Wraps the specified children with a tag named "name". Returns the newly new created tag node.

"startchild" and "endchild" should be children of the current node, and siblings, and not the null node. The position of "endchild" should be >= the position of "startchild". The behavior is undefined if any of these conditions are not met.

xmldomnode* xmldomnode::wrapChildren | ( | xmldomnode * | startchild,
|  | xmldomnode * | endchild,
|  | const char * | ns,
|  | const char * | name
| ) |  |

Wraps the specified children with a tag named "name" with namespace "ns". Returns the newly new created tag node.

"startchild" and "endchild" should be children of the current node, and siblings, and not the null node. The position of "endchild" should be >= the position of "startchild". The behavior is undefined if any of these conditions are not met.

xmldomnode* xmldomnode::wrapChildren | ( | const char * | name | ) |

Wraps all children of the current node with a tag named "name". Returns the newly new created tag node.

xmldomnode* xmldomnode::wrapChildren | ( | const char * | ns,
|  | const char * | name
| ) |  |

Wraps all children of the current node with a tag named "name" with namespace "ns". Returns the newly new created tag node.

stringbuffer* xmldomnode::xml | ( |  | ) | const

Allocates a stringbuffer, writes a text representation of the tree starting at this node to it and returns the stringbuffer; The calling program must deallocate the stringbuffer.